using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Data.Services;
using System.Data.Services.Common;
using System.Linq;
using System.Web.Mvc;
using DataAnnotationsExtensions;

namespace SWOG_GiveCamp.Entities
{
    [DataServiceKey("CharityRequirementId")]
    public class CharityRequirement
    {
        public CharityRequirement()
        {
            StaffTechnologies = new List<Technology>();
            ProjectTechnologies = new List<Technology>();
        }

        public int CharityRequirementId { get; set; }
        [Required]
        public string ContactName { get; set; }
        [Required]
        public string CharityName { get; set; }
        public string CallInstruction { get; set; }
        [Required(ErrorMessage = "We need to know something about your Charity")]
        [MaxLength(4000, ErrorMessage = "4000 Characters Maximum")]
        public string BackgroundInformation { get; set; }
        [Required]
        [MaxLength(1000, ErrorMessage = "1000 Characters Maximum")]
        public string WorkRequested { get; set; }
        [MaxLength(1000, ErrorMessage = "1000 Characters Maximum")]
        public string OtherInfrastructure { get; set; }
        [MaxLength(1000, ErrorMessage = "1000 Characters Maximum")]
        public string OtherSupportSkills { get; set; }
        [Required]
        [RegularExpression(@"((\(\d{3}\) ?)|(\d{3}-))?\d{3}-\d{4}",ErrorMessage = "Not a valid Phone Number")]
        public string PhoneNumber { get; set; }
        public string CurrentWebURL { get; set; }
        [Email]
        [Required]
        public string Email { get; set; }
        public bool? Selected { get; set; }

        [Required]
        public virtual ICollection<Technology> StaffTechnologies { get; set; }
        [Required]
        public virtual ICollection<Technology> ProjectTechnologies { get; set; }
    }

   
}