using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Data.Services.Common;
using DataAnnotationsExtensions;

namespace SWOG_GiveCamp.Entities
{
    [DataServiceKey("VolunteerID")]
	public class Volunteer
	{
	    public Volunteer()
		{
			this.JobRoles = new List<JobRole>();
			this.Technologies = new List<Technology>();
		}

		public int VolunteerID { get; set; }
        [Required]
		public string FirstName { get; set; }
        [Required]
		public string LastName { get; set; }
		public string TeamName { get; set; }
        [Email]
        [Required]
		public string EmailAddress { get; set; }
        [Required]
        [RegularExpression(@"((\(\d{3}\) ?)|(\d{3}-))?\d{3}-\d{4}", ErrorMessage = "Not a valid Phone Number")]
		public string PhoneNumber { get; set; }

	    public bool WillBeTeamLead { get; set; }
		public bool Student { get; set; }
		public string JobDescription { get; set; }
		public bool HasLaptop { get; set; }
		public bool HasExtraLaptop { get; set; }
		public bool GoodGuiDesigner { get; set; }
		public int ExperienceLevelID { get; set; }
		public int? YearsOfExperience { get; set; }
		public string DietaryNeeds { get; set; }
		public string TwitterHandle { get; set; }
		public string Bio { get; set; }
		public string Comments { get; set; }
		public virtual ExperienceLevel ExperienceLevel { get; set; }
		public virtual ICollection<JobRole> JobRoles { get; set; }
		public virtual ICollection<Technology> Technologies { get; set; }
	}
}

