﻿using System;
using System.Collections.Generic;
using System.Data.Entity.ModelConfiguration;
using System.Linq;
using System.Web;
using SWOG_GiveCamp.Entities;

namespace SWOG_GiveCamp.Mapping
{
    public class SponsorMap : EntityTypeConfiguration<Sponsor>
    {
        public SponsorMap()
        {
            this.HasKey(t => t.SponsorId);

            this.Property(t => t.SponsorId).HasColumnName("SponsorId");
            this.Property(t => t.SponsorTypeID).HasColumnName("SponsorTypeID");
            this.Property(t => t.ImageURL).HasColumnName("ImageURL");
            this.Property(t => t.NavigateURL).HasColumnName("NavigateURL");
            this.Property(t => t.AltText).HasColumnName("AltText");
            this.Property(t => t.SponsorName).HasColumnName("SponsorName");
            this.Property(t => t.DisplayOrder).HasColumnName("DisplayOrder");


            this.HasRequired(t => t.SponsorType)
                .WithMany(t => t.Sponsors)
                .HasForeignKey(d => d.SponsorTypeID);
        }
		
    }
}