using System;
using System.Data.Entity.ModelConfiguration;
using System.Data.Common;
using System.Data.Entity;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using SWOG_GiveCamp.Entities;

namespace SWOG_GiveCamp.Mapping
{
	public class TechnologyMap : EntityTypeConfiguration<Technology>
	{
		public TechnologyMap()
		{
			// Primary Key
			this.HasKey(t => t.TechnologyID);

			// Properties
			this.Property(t => t.Description)
				.IsRequired()
				.HasMaxLength(30);
				
			// Table & Column Mappings
			this.ToTable("Technologies");
			this.Property(t => t.TechnologyID).HasColumnName("TechnologyID");
			this.Property(t => t.Description).HasColumnName("Description");
			this.Property(t => t.DisplayOrder).HasColumnName("DisplayOrder");

			// Relationships
			this.HasMany(t => t.Volunteers)
			    .WithMany(t => t.Technologies)
				.Map(m =>
                    {
                        m.ToTable("VolunteerTechnologies");
                        m.MapLeftKey("TechnologyID");
                        m.MapRightKey("VolunteerID");
                    });
					
		}
	}
}

