using System;
using System.Data.Entity.ModelConfiguration;
using System.Data.Common;
using System.Data.Entity;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using SWOG_GiveCamp.Entities;

namespace SWOG_GiveCamp.Mapping
{
	public class vw_VolunteersMap : EntityTypeConfiguration<vw_Volunteers>
	{
		public vw_VolunteersMap()
		{
			// Primary Key
			this.HasKey(t => new { t.VolunteerID, t.FirstName, t.LastName, t.EmailAddress, t.PhoneNumber, t.Student, t.HasLaptop, t.HasExtraLaptop, t.ExperienceLevel });

			// Properties
			this.Property(t => t.VolunteerID)
				.HasDatabaseGeneratedOption(DatabaseGeneratedOption.None);
				
			this.Property(t => t.FirstName)
				.IsRequired()
				.HasMaxLength(30);
				
			this.Property(t => t.LastName)
				.IsRequired()
				.HasMaxLength(30);
				
			this.Property(t => t.TeamName)
				.HasMaxLength(30);
				
			this.Property(t => t.EmailAddress)
				.IsRequired()
				.HasMaxLength(255);
				
			this.Property(t => t.PhoneNumber)
				.IsRequired()
				.HasMaxLength(50);
				
			this.Property(t => t.Student)
				.IsRequired()
				.HasMaxLength(3);
				
			this.Property(t => t.JobDescription)
				.HasMaxLength(100);
				
			this.Property(t => t.HasLaptop)
				.IsRequired()
				.HasMaxLength(3);
				
			this.Property(t => t.HasExtraLaptop)
				.IsRequired()
				.HasMaxLength(3);
				
			this.Property(t => t.ExperienceLevel)
				.IsRequired()
				.HasMaxLength(30);
				
			this.Property(t => t.DietaryNeeds)
				.HasMaxLength(50);
				
			this.Property(t => t.TwitterHandle)
				.HasMaxLength(50);
				
			this.Property(t => t.Bio)
				.HasMaxLength(4000);
				
			this.Property(t => t.Comments)
				.HasMaxLength(4000);
				
			this.Property(t => t.Jobs)
				.HasMaxLength(1000);
				
			this.Property(t => t.Technologies)
				.HasMaxLength(1000);
				
			// Table & Column Mappings
			this.ToTable("vw_Volunteers");
			this.Property(t => t.VolunteerID).HasColumnName("VolunteerID");
			this.Property(t => t.FirstName).HasColumnName("FirstName");
			this.Property(t => t.LastName).HasColumnName("LastName");
			this.Property(t => t.TeamName).HasColumnName("TeamName");
			this.Property(t => t.EmailAddress).HasColumnName("EmailAddress");
			this.Property(t => t.PhoneNumber).HasColumnName("PhoneNumber");
			this.Property(t => t.Student).HasColumnName("Student");
			this.Property(t => t.JobDescription).HasColumnName("JobDescription");
			this.Property(t => t.HasLaptop).HasColumnName("HasLaptop");
			this.Property(t => t.HasExtraLaptop).HasColumnName("HasExtraLaptop");
			this.Property(t => t.ExperienceLevel).HasColumnName("ExperienceLevel");
			this.Property(t => t.YearsOfExperience).HasColumnName("YearsOfExperience");
			this.Property(t => t.DietaryNeeds).HasColumnName("DietaryNeeds");
			this.Property(t => t.TwitterHandle).HasColumnName("TwitterHandle");
			this.Property(t => t.Bio).HasColumnName("Bio");
			this.Property(t => t.Comments).HasColumnName("Comments");
			this.Property(t => t.Jobs).HasColumnName("Jobs");
			this.Property(t => t.Technologies).HasColumnName("Technologies");
		}
	}
}

