using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Linq.Expressions;
using System.Web;
using SWOG_GiveCamp.Entities;
using SWOG_GiveCamp;

namespace SWOG_GiveCamp.Models
{ 
    public class CharityRequirementRepository : ICharityRequirementRepository
    {
        GiveCampContext context = App.Db;

        public IQueryable<CharityRequirement> All
        {
            get { return context.CharityRequirements; }
        }

        public IQueryable<CharityRequirement> AllIncluding(params Expression<Func<CharityRequirement, object>>[] includeProperties)
        {
            IQueryable<CharityRequirement> query = context.CharityRequirements;
            foreach (var includeProperty in includeProperties) {
                query = query.Include(includeProperty);
            }
            return query;
        }

        public CharityRequirement Find(int id)
        {
            return context.CharityRequirements.Find(id);
        }

        public void InsertOrUpdate(CharityRequirement charityrequirement)
        {
            if (charityrequirement.CharityRequirementId == default(int)) {
                // New entity
                context.CharityRequirements.Add(charityrequirement);
            } else {
                // Existing entity
                context.Entry(charityrequirement).State = EntityState.Modified;
            }
        }

        public void Delete(int id)
        {
            var charityrequirement = context.CharityRequirements.Find(id);
            context.CharityRequirements.Remove(charityrequirement);
        }

        public void Save()
        {
            context.SaveChanges();
        }
    }

    public interface ICharityRequirementRepository
    {
        IQueryable<CharityRequirement> All { get; }
        IQueryable<CharityRequirement> AllIncluding(params Expression<Func<CharityRequirement, object>>[] includeProperties);
        CharityRequirement Find(int id);
        void InsertOrUpdate(CharityRequirement charityrequirement);
        void Delete(int id);
        void Save();
    }
}