﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Mail;
using System.Text;
using System.Web;

namespace SWOG_GiveCamp.Models
{
    public class MailRepo
    {
        public void SendMail(string to,string Message)
        {
            var strFrom = "NoReply@Southwestohiogivecamp.org";
            var MailMsg = new MailMessage(new MailAddress(strFrom.Trim()), new MailAddress(to));
            MailMsg.BodyEncoding = Encoding.Default;
            MailMsg.Subject = "Southwest Ohio Givecamp Confirmation";
            MailMsg.Body = "This is a sample message";
            MailMsg.Priority = MailPriority.High;
            MailMsg.IsBodyHtml = true;
            //Smtpclient to send the mail message
            var SmtpMail = new SmtpClient("smtp.gmail.com");
            SmtpMail.EnableSsl = true;
            NetworkCredential Credentials = new NetworkCredential("NoReply@southwestohiogivecamp.org", "noreply@all");
            SmtpMail.Credentials = Credentials;
            //SmtpMail.Host = "localhost";
            SmtpMail.Send(MailMsg);

            //SmtpClient smtp = new SmtpClient("smtp.stockpickermax.com", 25);
           

            //smtp.Send(mail); 
        }
        public void SendCharityAcknowledgement(Entities.CharityRequirementVM Charity)
        {
            var strFrom = "NoReply@Southwestohiogivecamp.org";
            var MailMsg = new MailMessage();
            MailMsg.From = new MailAddress(strFrom);
            MailMsg.To.Add(new MailAddress(Charity.Email));
            MailMsg.CC.Add(new MailAddress("Ernie@southwestohiogivecamp.org"));
            MailMsg.CC.Add(new MailAddress("charities@southwestohiogivecamp.org"));
            MailMsg.BodyEncoding = Encoding.Default;
            MailMsg.Subject = "Southwest Ohio Givecamp Charity Submission Confirmation";
            MailMsg.Body = getCharityMessage(Charity);
            MailMsg.Priority = MailPriority.High;
            MailMsg.IsBodyHtml = false;
            //Smtpclient to send the mail message
            var SmtpMail = new SmtpClient("smtp.gmail.com");
            SmtpMail.EnableSsl = true;
            NetworkCredential Credentials = new NetworkCredential("NoReply@southwestohiogivecamp.org", "noreply@all");
            SmtpMail.Credentials = Credentials;
            //SmtpMail.Host = "localhost";
            SmtpMail.Send(MailMsg);

            //SmtpClient smtp = new SmtpClient("smtp.stockpickermax.com", 25);


            //smtp.Send(mail); 
        }
        private string getCharityMessage(Entities.CharityRequirementVM Charity)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("Thank you for Submitting your charity application");
            sb.Append(Environment.NewLine);
            sb.AppendLine(string.Format("Southwest Ohio Give Camp thanks you for submitting your charity, {0}.  ",Charity.CharityName));
            sb.Append(Environment.NewLine);
            sb.AppendLine(string.Format("Contact Name: {0}", Charity.ContactName));
            sb.Append(Environment.NewLine);
            sb.AppendLine(string.Format("Contact Email: {0}", Charity.Email));
            sb.Append(Environment.NewLine);
            sb.AppendLine(string.Format("Contact Phone: {0}", Charity.PhoneNumber));
            sb.Append(Environment.NewLine);
            sb.AppendLine("The initial selection process will be completed in August, and all applicants will be contacted at that time.");
            sb.Append(Environment.NewLine);
            sb.AppendLine("Thanks Again,");
            sb.Append(Environment.NewLine);
            sb.AppendLine("Southwest Ohio Give Camp Team");
            return sb.ToString();
        }

        internal void SendVolunteerAcknowledgement(Entities.VolunteerVM volunteerVM)
        {
            var strFrom = "NoReply@Southwestohiogivecamp.org";
            var MailMsg = new MailMessage();
            MailMsg.From = new MailAddress(strFrom);
            MailMsg.To.Add(new MailAddress(volunteerVM.EmailAddress));
            MailMsg.CC.Add(new MailAddress("Ernie@southwestohiogivecamp.org"));
            MailMsg.CC.Add(new MailAddress("developer@southwestohiogivecamp.org"));
            MailMsg.BodyEncoding = Encoding.Default;
            MailMsg.Subject = "Southwest Ohio Givecamp Volunteer Registration Confirmation";
            MailMsg.Body = getVolunteerMessage(volunteerVM);
            MailMsg.Priority = MailPriority.High;
            MailMsg.IsBodyHtml = false;
            //Smtpclient to send the mail message
            var SmtpMail = new SmtpClient("smtp.gmail.com");
            SmtpMail.EnableSsl = true;
            NetworkCredential Credentials = new NetworkCredential("NoReply@southwestohiogivecamp.org", "noreply@all");
            SmtpMail.Credentials = Credentials;
            SmtpMail.Send(MailMsg);
        }

        private string getVolunteerMessage(Entities.VolunteerVM volunteerVM)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("Thank you for Registering to Volunteer for the Southwest Ohio Give Camp, October 21 – 23, 2011");
            sb.Append(Environment.NewLine);
            sb.AppendLine("We have recorded the following contact information for you:");
            sb.Append(Environment.NewLine);
            sb.AppendLine(string.Format("Contact Name: {0}", string.Format("{0} {1}",volunteerVM.FirstName,volunteerVM.LastName)));
            sb.Append(Environment.NewLine);
            sb.AppendLine(string.Format("Contact Email: {0}", volunteerVM.EmailAddress));
            sb.Append(Environment.NewLine);
            sb.AppendLine(string.Format("Contact Phone: {0}", volunteerVM.PhoneNumber));
            sb.Append(Environment.NewLine);
            sb.AppendLine("Thank you for registering to volunteer.  We will be sending out routine updates as the event approaches.");
            sb.Append(Environment.NewLine);
            sb.AppendLine("Southwest Ohio Give Camp Team");
            return sb.ToString();
        }
    }
}